## iproute2 4.15.0

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
# Top level Makefile for iproute2

ifeq ("$(origin V)", "command line")
VERBOSE = $(V)
endif
ifndef VERBOSE
VERBOSE = 0
endif

ifeq ($(VERBOSE),0)
MAKEFLAGS += --no-print-directory
endif

PREFIX?=/usr
LIBDIR?=$(PREFIX)/lib
SBINDIR?=/sbin
CONFDIR?=/etc/iproute2
DATADIR?=$(PREFIX)/share
HDRDIR?=$(PREFIX)/include/iproute2
DOCDIR?=$(DATADIR)/doc/iproute2
MANDIR?=$(DATADIR)/man
ARPDDIR?=/var/lib/arpd
KERNEL_INCLUDE?=/usr/include
BASH_COMPDIR?=$(DATADIR)/bash-completion/completions

# Path to db_185.h include
DBM_INCLUDE:=$(DESTDIR)/usr/include

SHARED_LIBS = y

DEFINES= -DRESOLVE_HOSTNAMES -DLIBDIR=\"$(LIBDIR)\"
ifneq ($(SHARED_LIBS),y)
DEFINES+= -DNO_SHARED_LIBS
endif

DEFINES+=-DCONFDIR=\"$(CONFDIR)\"

#options for decnet
ADDLIB+=dnet_ntop.o dnet_pton.o

#options for ipx
ADDLIB+=ipx_ntop.o ipx_pton.o

#options for mpls
ADDLIB+=mpls_ntop.o mpls_pton.o

CC := gcc
HOSTCC ?= $(CC)
DEFINES += -D_GNU_SOURCE
# Turn on transparent support for LFS
DEFINES += -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
CCOPTS = -O2
WFLAGS := -Wall -Wstrict-prototypes  -Wmissing-prototypes
WFLAGS += -Wmissing-declarations -Wold-style-definition -Wformat=2

CFLAGS := $(WFLAGS) $(CCOPTS) -I../include -I../include/uapi $(DEFINES) $(CFLAGS)
YACCFLAGS = -d -t -v

SUBDIRS=lib ip tc bridge misc netem genl tipc devlink rdma man

LIBNETLINK=../lib/libnetlink.a ../lib/libutil.a
LDLIBS += $(LIBNETLINK)

all: config.mk
	@set -e; \
	for i in $(SUBDIRS); \
	do echo; echo $$i; $(MAKE) $(MFLAGS) -C $$i; done

config.mk:
	sh configure $(KERNEL_INCLUDE)

install: all
	install -m 0755 -d $(DESTDIR)$(SBINDIR)
	install -m 0755 -d $(DESTDIR)$(CONFDIR)
	install -m 0755 -d $(DESTDIR)$(ARPDDIR)
	install -m 0755 -d $(DESTDIR)$(HDRDIR)
	install -m 0755 -d $(DESTDIR)$(DOCDIR)/examples
	install -m 0755 -d $(DESTDIR)$(DOCDIR)/examples/diffserv
	install -m 0644 README.iproute2+tc $(shell find examples -maxdepth 1 -type f) \
		$(DESTDIR)$(DOCDIR)/examples
	install -m 0644 $(shell find examples/diffserv -maxdepth 1 -type f) \
		$(DESTDIR)$(DOCDIR)/examples/diffserv
	@for i in $(SUBDIRS);  do $(MAKE) -C $$i install; done
	install -m 0644 $(shell find etc/iproute2 -maxdepth 1 -type f) $(DESTDIR)$(CONFDIR)
	install -m 0755 -d $(DESTDIR)$(BASH_COMPDIR)
	install -m 0644 bash-completion/tc $(DESTDIR)$(BASH_COMPDIR)
	install -m 0644 include/bpf_elf.h $(DESTDIR)$(HDRDIR)

snapshot:
	echo "static const char SNAPSHOT[] = \""`date +%y%m%d`"\";" \
		> include/SNAPSHOT.h

clean:
	@for i in $(SUBDIRS); \
	do $(MAKE) $(MFLAGS) -C $$i clean; done

clobber:
	touch config.mk
	$(MAKE) $(MFLAGS) clean
	rm -f config.mk cscope.*

distclean: clobber

cscope:
	cscope -b -q -R -Iinclude -sip -slib -smisc -snetem -stc

.EXPORT_ALL_VARIABLES:

=== ip/Makefile ===
# SPDX-License-Identifier: GPL-2.0
IPOBJ=ip.o ipaddress.o ipaddrlabel.o iproute.o iprule.o ipnetns.o \
    rtm_map.o iptunnel.o ip6tunnel.o tunnel.o ipneigh.o ipntable.o iplink.o \
    ipmaddr.o ipmonitor.o ipmroute.o ipprefix.o iptuntap.o iptoken.o \
    ipxfrm.o xfrm_state.o xfrm_policy.o xfrm_monitor.o iplink_dummy.o \
    iplink_ifb.o iplink_nlmon.o iplink_team.o iplink_vcan.o iplink_vxcan.o \
    iplink_vlan.o link_veth.o link_gre.o iplink_can.o iplink_xdp.o \
    iplink_macvlan.o ipl2tp.o link_vti.o link_vti6.o \
    iplink_vxlan.o tcp_metrics.o iplink_ipoib.o ipnetconf.o link_ip6tnl.o \
    link_iptnl.o link_gre6.o iplink_bond.o iplink_bond_slave.o iplink_hsr.o \
    iplink_bridge.o iplink_bridge_slave.o ipfou.o iplink_ipvlan.o \
    iplink_geneve.o iplink_vrf.o iproute_lwtunnel.o ipmacsec.o ipila.o \
    ipvrf.o iplink_xstats.o ipseg6.o

RTMONOBJ=rtmon.o

include ../config.mk

ALLOBJ=$(IPOBJ) $(RTMONOBJ)
SCRIPTS=ifcfg rtpr routel routef
TARGETS=ip rtmon

all: $(TARGETS) $(SCRIPTS)

ip: $(IPOBJ) $(LIBNETLINK)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

rtmon: $(RTMONOBJ)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	install -m 0755 $(TARGETS) $(DESTDIR)$(SBINDIR)
	install -m 0755 $(SCRIPTS) $(DESTDIR)$(SBINDIR)

clean:
	rm -f $(ALLOBJ) $(TARGETS)

SHARED_LIBS ?= y
ifeq ($(SHARED_LIBS),y)

LDLIBS += -ldl
LDFLAGS += -Wl,-export-dynamic

else

ip: static-syms.o
static-syms.o: static-syms.h
static-syms.h: $(wildcard *.c)
	files="$^" ; \
	for s in `grep -B 3 '\<dlsym' $$files | sed -n '/snprintf/{s:.*"\([^"]*\)".*:\1:;s:%s::;p}'` ; do \
		sed -n '/'$$s'[^ ]* =/{s:.* \([^ ]*'$$s'[^ ]*\) .*:extern char \1[] __attribute__((weak)); if (!strcmp(sym, "\1")) return \1;:;p}' $$files ; \
	done > $@

endif

=== rdma/Makefile ===
# SPDX-License-Identifier: GPL-2.0
include ../config.mk

TARGETS :=

ifeq ($(HAVE_MNL),y)

RDMA_OBJ = rdma.o utils.o dev.o link.o

TARGETS += rdma
endif

all:	$(TARGETS) $(LIBS)

rdma:	$(RDMA_OBJ) $(LIBS)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	install -m 0755 $(TARGETS) $(DESTDIR)$(SBINDIR)

clean:
	rm -f $(RDMA_OBJ) $(TARGETS)

=== testsuite/iproute2/Makefile ===
# SPDX-License-Identifier: GPL-2.0
SUBDIRS := $(filter-out Makefile,$(wildcard *))
.PHONY: all configure clean distclean show $(SUBDIRS)

all: configure
	@for dir in $(SUBDIRS); do \
		echo "Entering $$dir" && cd $$dir && $(MAKE) && cd ..; \
	done

link:
	@if [ ! -L iproute2-this ]; then \
		ln -s ../.. iproute2-this; \
	fi

configure: link
	@for dir in $(SUBDIRS); do \
		echo "Entering $$dir" && cd $$dir && if [ -f configure ]; then ./configure; fi && cd ..; \
	done

clean: link
	@for dir in $(SUBDIRS); do \
		echo "Entering $$dir" && cd $$dir && $(MAKE) clean && cd ..; \
	done

distclean: clean
	@for dir in $(SUBDIRS); do \
		echo "Entering $$dir" && cd $$dir && $(MAKE) distclean && cd ..; \
	done

show: link
	@echo "$(SUBDIRS)"

$(SUBDIRS):
	cd $@ && $(MAKE)

=== debian/changelog ===
iproute2 (4.15.0-2ubuntu1.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Use-after-free
    - debian/patches/CVE-2019-20795.patch: fix a user-after-free in
      ip/ipnetns.c in get_netnsid_from_name.
    - CVE-2019-20795

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 11 May 2020 11:40:47 -0300

iproute2 (4.15.0-2ubuntu1) bionic; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - debian/patches/1000-ubuntu-poc-fan-driver.patch
      Ubuntu FAN driver support V2 (LP 1439706)
    - debian/patches/1001-ubuntu-poc-fan-driver-v3.patch
      Ubuntu FAN driver support V3 (LP 1470091)
    - debian/patches/1002-ubuntu-poc-fan-driver-vxlan.patch
      Ubuntu FAN driver support VXLAN V4
    - drop debian/patches/0001-Add-moo-feature.patch
    - set compat level 10 (no further changes needed)
    - Add: d/p/netns-allow-negative-nsid: permit negative nsid using "auto"
  * Dropped changes (in Debian):
    - follow upstream dropping the old ip documentation (of 1999)
    - d/rules: consider DEB_*_GNU_TYPE from env
    - d/control: bump debhelper dependency and Standards-Version
    - drop 0003-fix-segfault-with-iptables-1.6.patch (upstream)
    - d/control: fix lintian priority-extra-is-replaced-by-priority-optional
    - d/t/control: d/t/testsuite.sh: add iproute2 testsuite as autopkgtest
  * Dropped changes (upstream):
    - d/p/fix-testsuite-broken-pipes.patch: avoid broken pipe errors in tests
  * Added changes:
   - Refresh: d/p/*ubuntu-poc-fan-driver*.patch to latest upstream

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 26 Feb 2018 16:21:30 +0100

iproute2 (4.15.0-2) unstable; urgency=medium

  * Update upstream git repository URL. (Closes: #888804)

 -- Luca Boccassi <bluca@debian.org>  Sun, 18 Feb 2018 11:46:22 +0000

iproute2 (4.15.0-1) experimental; urgency=medium

  * Fix FTCBFS: Pass HOSTCC and PKG_CONFIG variables via CROSS.
    Thanks Helmut Grohne! (Closes: #888404)
  * Merge tag 'upstream/4.15.0' (Closes: #561424 #661886 #877983).
  * Drop 0005-fix-manpage-path.patch, fixed upstream.
  * Drop 0006-fix-testsuite-broken-pipes.patch, merged upstream.

 -- Luca Boccassi <bluca@debian.org>  Tue, 30 Jan 2018 14:51:52 +0000

iproute2 (4.14.1-2) unstable; urgency=medium

  * iproute2-doc: set it to Multiarch: foreign - no dependencies
    and no mainteiner script, just contains text files.
  * Do not override dpkg architecture variables if already set by
    dpkg-buildpackage.
    LW: debian-rules-sets-dpkg-architecture-variable
  * Drop iproute and iproute-doc transitional packages, as they
    have already shipped in Jessie and Stretch. (Closes: #878602)
  * Drop build-dependencies that are no longer necessary since
    upstream dropped all non-manpages docs. (Closes: #856473)
  * Update Standards-Version to 4.1.3:
    - dropped all "extra" priority packages
    - build reproducible out-of-the-box since 4.14.0
  * Add 0005-fix-manpage-path.patch to fix paths to documentation
    files in the manpages. (Closes: #819131, #867875)
  * Import autopkgtest (and 0006-fix-testsuite-broken-pipes.patch)
    from Ubuntu. Thanks Christian Ehrhardt!
  * Drop out-of-tree htb docs as they are not upstream and very,
    very old. (Closes: #617650)
  * Install the rdma binary. (Closes: #886231)
  * Switch from Alioth to Salsa and update VCS metadata.

 -- Luca Boccassi <bluca@debian.org>  Wed, 24 Jan 2018 19:19:17 +0000

iproute2 (4.14.1-1) unstable; urgency=medium

  * Merge tag 'upstream/4.14.1'
  * Drop 0002-txtdocs.patch, not needed anymore.
  * Remove rules and matches for old iproute doc, removed upstream.
  * B-D on zlib1g-dev as a workaround for #885071.

 -- Luca Boccassi <bluca@debian.org>  Sat, 23 Dec 2017 14:55:10 +0100

iproute2 (4.14.1-0ubuntu3) bionic; urgency=medium

  [ Christian Brauner ]
  * d/p/netns-allow-negative-nsid: permit negative nsid using "auto".

 -- Robie Basak <robie.basak@ubuntu.com>  Thu, 15 Feb 2018 15:03:56 +0000

iproute2 (4.14.1-0ubuntu2) bionic; urgency=medium

  * d/p/1002-ubuntu-poc-fan-driver-vxlan.patch: update to fix fan-map
    processing in vxlan_parse_opt in new version of iproute2.

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 11 Dec 2017 12:13:50 +0100

iproute2 (4.14.1-0ubuntu1) bionic; urgency=medium

  [ Christian Ehrhardt ]
  * Merge from Debian unstable AND latest upstream (LP: #1726730)
    (LP: #1735032). Remaining changes:
    - debian/patches/1000-ubuntu-poc-fan-driver.patch
      Ubuntu FAN driver support V2 (LP 1439706)
    - debian/patches/1001-ubuntu-poc-fan-driver-v3.patch
      Ubuntu FAN driver support V3 (LP 1470091)
    - debian/patches/1002-ubuntu-poc-fan-driver-vxlan.patch
      Ubuntu FAN driver support VXLAN V4.
  * Dropped changes (upstream now)
    - Fix ip maddr show (LP 1732032):
      - d/p/1003-ip-maddr-fix-igmp-parsing.patch: fix igmp parsing when iface is
        long
      - d/p/1004-ip-maddr-avoid-uninitialized-data.patch: avoid accessing
        uninitialized data
      - d/p/1005-ip-maddr-fix-filtering-by-device.patch: fix filtering
        by device
    - d/p/1006-fix-undeclared-UINT16_MAX.patch: FTBFS: tc: include stdint.h
      explicitly for UINT16_MAX (LP 1735158)
  * Added changes
    - drop 0003-fix-segfault-with-iptables-1.6.patch (upstream)
    - update d/p/*ubuntu-poc-fan-driver*.patch to latest upstream
    - d/control: fix lintian priority-extra-is-replaced-by-priority-optional
    - d/t/control: d/t/testsuite.sh: add iproute2 testsuite as autopkgtest
    - d/p/fix-testsuite-broken-pipes.patch: avoid broken pipe errors in tests

  [ Julian Wollrath <jwollrath@web.de> ]
  * Added changes based on suggested 4.14.1-0 changes for Debian in bug 879854
    - dropped d/p/0001-Add-moo-feature.patch (isn't needed)
    - follow upstream dropping the old ip documentation (of 1999)
    - d/rules: consider DEB_*_GNU_TYPE from env
    - d/control: bump debhelper dependency and Standards-Version
    - set compat level 10 (no further changes needed)



=== debian/control ===
Source: iproute2
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alexander Wirt <formorer@debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>
Homepage: https://wiki.linuxfoundation.org/networking/iproute2
Vcs-Browser: https://salsa.debian.org/debian/iproute2.git
Vcs-Git: https://salsa.debian.org/debian/iproute2.git
Standards-Version: 4.1.3
Build-Depends: bison,
               debhelper (>= 9),
               flex,
               iptables-dev,
               libatm1-dev,
               libdb-dev,
               libelf-dev,
               libmnl-dev,
               libselinux1-dev,
               linux-libc-dev,
               pkg-config,
               zlib1g-dev,

Package: iproute2
Priority: important
Architecture: any
Provides: arpd
Conflicts: arpd, iproute (<< 20130000-1)
Replaces: iproute
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ${ipmods:Recommends}
Suggests: iproute2-doc
Multi-Arch: foreign
Description: networking and traffic control tools
 The iproute2 suite is a collection of utilities for networking and
 traffic control.
 .
 These tools communicate with the Linux kernel via the (rt)netlink
 interface, providing advanced features not available through the
 legacy net-tools commands 'ifconfig' and 'route'.

Package: iproute2-doc
Section: doc
Architecture: all
Conflicts: iproute-doc (<< 20130000-1)
Replaces: iproute-doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: networking and traffic control tools - documentation
 The iproute2 suite is a collection of utilities for networking and
 traffic control.
 .
 This package contains the documentation for iproute.

## iproute2 4.18.0

=== devlink/Makefile ===
# SPDX-License-Identifier: GPL-2.0
include ../config.mk

TARGETS :=

ifeq ($(HAVE_MNL),y)

DEVLINKOBJ = devlink.o mnlg.o
TARGETS += devlink

CFLAGS += $(shell $(PKG_CONFIG) libmnl --cflags)
LDLIBS += $(shell $(PKG_CONFIG) libmnl --libs)

endif

all: $(TARGETS) $(LIBS)

devlink: $(DEVLINKOBJ)
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

install: all
	install -m 0755 $(TARGETS) $(DESTDIR)$(SBINDIR)

clean:
	rm -f $(DEVLINKOBJ) $(TARGETS)

=== man/Makefile ===
# SPDX-License-Identifier: GPL-2.0
INSTALL=install
INSTALLDIR=install -m 0755 -d
INSTALLMAN=install -m 0644

SUBDIRS = man3 man7 man8

all clean install:
	@for subdir in $(SUBDIRS); do $(MAKE) -C $$subdir $@ || exit $$?; done

distclean: clean

.PHONY: install clean distclean

.EXPORT_ALL_VARIABLES:

=== tc/Makefile ===
# SPDX-License-Identifier: GPL-2.0
TCOBJ= tc.o tc_qdisc.o tc_class.o tc_filter.o tc_util.o tc_monitor.o \
       tc_exec.o m_police.o m_estimator.o m_action.o m_ematch.o \
       emp_ematch.yacc.o emp_ematch.lex.o

include ../config.mk

SHARED_LIBS ?= y

TCMODULES :=
TCMODULES += q_fifo.o
TCMODULES += q_sfq.o
TCMODULES += q_red.o
TCMODULES += q_prio.o
TCMODULES += q_tbf.o
TCMODULES += q_cbq.o
TCMODULES += q_rr.o
TCMODULES += q_multiq.o
TCMODULES += q_netem.o
TCMODULES += q_choke.o
TCMODULES += q_sfb.o
TCMODULES += f_rsvp.o
TCMODULES += f_u32.o
TCMODULES += f_route.o
TCMODULES += f_fw.o
TCMODULES += f_basic.o
TCMODULES += f_bpf.o
TCMODULES += f_flow.o
TCMODULES += f_cgroup.o
TCMODULES += f_flower.o
TCMODULES += q_dsmark.o
TCMODULES += q_gred.o
TCMODULES += f_tcindex.o
TCMODULES += q_ingress.o
TCMODULES += q_hfsc.o
TCMODULES += q_htb.o
TCMODULES += q_drr.o
TCMODULES += q_qfq.o
TCMODULES += m_gact.o
TCMODULES += m_mirred.o
TCMODULES += m_nat.o
TCMODULES += m_pedit.o
TCMODULES += m_ife.o
TCMODULES += m_skbedit.o
TCMODULES += m_skbmod.o
TCMODULES += m_csum.o
TCMODULES += m_simple.o
TCMODULES += m_vlan.o
TCMODULES += m_connmark.o
TCMODULES += m_bpf.o
TCMODULES += m_tunnel_key.o
TCMODULES += m_sample.o
TCMODULES += p_ip.o
TCMODULES += p_ip6.o
TCMODULES += p_icmp.o
TCMODULES += p_eth.o
TCMODULES += p_tcp.o
TCMODULES += p_udp.o
TCMODULES += em_nbyte.o
TCMODULES += em_cmp.o
TCMODULES += em_u32.o
TCMODULES += em_canid.o
TCMODULES += em_meta.o
TCMODULES += q_mqprio.o
TCMODULES += q_codel.o
TCMODULES += q_fq_codel.o
TCMODULES += q_fq.o
TCMODULES += q_pie.o
TCMODULES += q_hhf.o
TCMODULES += q_clsact.o
TCMODULES += e_bpf.o
TCMODULES += f_matchall.o
TCMODULES += q_cbs.o

TCSO :=
ifeq ($(TC_CONFIG_ATM),y)
  TCSO += q_atm.so
endif

ifneq ($(TC_CONFIG_NO_XT),y)
  ifeq ($(TC_CONFIG_XT),y)
    TCSO += m_xt.so
    TCMODULES += em_ipt.o
    ifeq ($(TC_CONFIG_IPSET),y)
      TCMODULES += em_ipset.o
    endif
  else
    ifeq ($(TC_CONFIG_XT_OLD),y)
      TCSO += m_xt_old.so
    else
      ifeq ($(TC_CONFIG_XT_OLD_H),y)
        CFLAGS += -DTC_CONFIG_XT_H
        TCSO += m_xt_old.so
      else
        TCMODULES += m_ipt.o
      endif
    endif
  endif
endif

TCOBJ += $(TCMODULES)
LDLIBS += -L. -lm

ifeq ($(SHARED_LIBS),y)
LDLIBS += -ldl
LDFLAGS += -Wl,-export-dynamic
endif

TCLIB := tc_core.o
TCLIB += tc_red.o
TCLIB += tc_cbq.o
TCLIB += tc_estimator.o
TCLIB += tc_stab.o

CFLAGS += -DCONFIG_GACT -DCONFIG_GACT_PROB
ifneq ($(IPT_LIB_DIR),)
	CFLAGS += -DIPT_LIB_DIR=\"$(IPT_LIB_DIR)\"
endif

YACC := bison
LEX := flex
CFLAGS += -DYY_NO_INPUT

MODDESTDIR := $(DESTDIR)$(LIBDIR)/tc

%.so: %.c
	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -shared -fpic $< -o $@


all: tc $(TCSO)

tc: $(TCOBJ) $(LIBNETLINK) libtc.a
	$(QUIET_LINK)$(CC) $^ $(LDFLAGS) $(LDLIBS) -o $@

libtc.a: $(TCLIB)
	$(QUIET_AR)$(AR) rcs $@ $^

install: all
	mkdir -p $(MODDESTDIR)
	install -m 0755 tc $(DESTDIR)$(SBINDIR)
	for i in $(TCSO); \
	do install -m 755 $$i $(MODDESTDIR); \
	done
	if [ ! -f $(MODDESTDIR)/m_ipt.so ]; then \
	if [ -f $(MODDESTDIR)/m_xt.so ]; \
		then ln -s m_xt.so $(MODDESTDIR)/m_ipt.so ; \
	elif [ -f $(MODDESTDIR)/m_xt_old.so ]; \
		then ln -s m_xt_old.so $(MODDESTDIR)/m_ipt.so ; \
	fi; \
	fi

clean:
	rm -f $(TCOBJ) $(TCLIB) libtc.a tc *.so emp_ematch.yacc.h; \
	rm -f emp_ematch.yacc.*

q_atm.so: q_atm.c
	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -shared -fpic -o q_atm.so q_atm.c -latm

m_xt.so: m_xt.c
	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -shared -fpic -o m_xt.so m_xt.c $$($(PKG_CONFIG) xtables --cflags --libs)

m_xt_old.so: m_xt_old.c
	$(QUIET_CC)$(CC) $(CFLAGS) $(LDFLAGS) -shared -fpic -o m_xt_old.so m_xt_old.c $$($(PKG_CONFIG) xtables --cflags --libs)

em_ipset.o: CFLAGS += $$($(PKG_CONFIG) xtables --cflags)

em_ipt.o: CFLAGS += $$($(PKG_CONFIG) xtables --cflags)

ifeq ($(TC_CONFIG_XT),y)
  LDFLAGS += $$($(PKG_CONFIG) xtables --libs)
endif

%.yacc.c: %.y
	$(QUIET_YACC)$(YACC) $(YACCFLAGS) -o $@ $<

%.lex.c: %.l
	$(QUIET_LEX)$(LEX) $(LEXFLAGS) -o$@ $<

# our lexer includes the header from yacc, so make sure
# we don't attempt to compile it before the header has
# been generated as part of the yacc step.
emp_ematch.lex.o: emp_ematch.yacc.c

ifneq ($(SHARED_LIBS),y)

tc: static-syms.o
static-syms.o: static-syms.h
static-syms.h: $(wildcard *.c)
	files="$^" ; \
	for s in `grep -B 3 '\<dlsym' $$files | sed -n '/snprintf/{s:.*"\([^"]*\)".*:\1:;s:%s::;p}'` ; do \
		sed -n '/'$$s'[^ ]* =/{s:.* \([^ ]*'$$s'[^ ]*\) .*:extern char \1[] __attribute__((weak)); if (!strcmp(sym, "\1")) return \1;:;p}' $$files ; \
	done > $@

endif

=== testsuite/Makefile ===
# SPDX-License-Identifier: GPL-2.0
## -- Config --
DEV := lo
PREFIX := sudo -E unshare -n
RESULTS_DIR := results
## -- End Config --

HAVE_UNSHARED_UTIL := $(shell unshare --version 2> /dev/null)

rwildcard=$(wildcard $1$2) $(foreach d,$(wildcard $1*),$(call rwildcard,$d/,$2))

TESTS := $(patsubst tests/%,%,$(call rwildcard,tests/,*.t))
TESTS_DIR := $(dir $(TESTS))

IPVERS := $(filter-out iproute2/Makefile,$(wildcard iproute2/*))

ifneq (,$(wildcard /proc/config.gz))
	KENV := $(shell cat /proc/config.gz | gunzip | grep ^CONFIG)
else
KVER := $(shell uname -r)
KCPATHS := /lib/modules/$(KVER)/config /boot/config-$(KVER)
KCPATH := $(firstword $(wildcard $(KCPATHS)))
ifneq (,$(KCPATH))
	KENV := $(shell cat ${KCPATH} | grep ^CONFIG)
endif
endif

.PHONY: compile listtests alltests configure $(TESTS)

configure:
	echo "Entering iproute2" && cd iproute2 && $(MAKE) configure && cd ..;

compile: configure
	echo "Entering iproute2" && cd iproute2 && $(MAKE) && cd ..;

listtests:
	@for t in $(TESTS); do \
		echo "$$t"; \
	done

alltests: $(TESTS)

clean:
	@echo "Removing $(RESULTS_DIR) dir ..."
	@rm -rf $(RESULTS_DIR)

distclean: clean
	echo "Entering iproute2" && cd iproute2 && $(MAKE) distclean && cd ..;

$(TESTS): clean
ifeq (,$(HAVE_UNSHARED_UTIL))
	$(error Please install util-linux tools to run tests in separated network namespace)
endif
	@./tools/generate_nlmsg

	@mkdir -p $(RESULTS_DIR)
	
	@for d in $(TESTS_DIR); do \
	    mkdir -p $(RESULTS_DIR)/$$d; \
	done
	
	@for i in $(IPVERS); do \
		o=`echo $$i | sed -e 's/iproute2\///'`; \
		echo -n "Running $@ [$$o/`uname -r`]: "; \
		TMP_ERR=`mktemp /tmp/tc_testsuite.XXXXXX`; \
		TMP_OUT=`mktemp /tmp/tc_testsuite.XXXXXX`; \
		STD_ERR="$$TMP_ERR" STD_OUT="$$TMP_OUT" \
		TC="$$i/tc/tc" IP="$$i/ip/ip" DEV="$(DEV)" IPVER="$@" SNAME="$$i" \
		ERRF="$(RESULTS_DIR)/$@.$$o.err" $(KENV) $(PREFIX) tests/$@ > $(RESULTS_DIR)/$@.$$o.out; \
		if [ "$$?" = "127" ]; then \
			echo "SKIPPED"; \
		elif [ -e "$(RESULTS_DIR)/$@.$$o.err" ]; then \
			echo "FAILED"; \
		else \
			echo "PASS"; \
		fi; \
		rm "$$TMP_ERR" "$$TMP_OUT"; \
		dmesg > $(RESULTS_DIR)/$@.$$o.dmesg; \
	done

=== testsuite/tools/Makefile ===
# SPDX-License-Identifier: GPL-2.0
generate_nlmsg: generate_nlmsg.c ../../lib/libnetlink.c
	$(CC) -o $@ $^

=== debian/changelog ===
iproute2 (4.18.0-1ubuntu2~ubuntu18.04.1) bionic-backports; urgency=medium

  [ Alfonso Sanchez-Beato ]
  * No-change backport to bionic

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 21 Mar 2019 09:38:42 +0100

iproute2 (4.18.0-1ubuntu2) cosmic; urgency=low

  * d/p/1006-ubuntu-iprule-fix-output.patch
    Fix destination prefix output of "ip rule show" (LP: #1789431).

 -- Stefan Bader <stefan.bader@canonical.com>  Tue, 28 Aug 2018 16:38:47 +0200

iproute2 (4.18.0-1ubuntu1) cosmic; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Add: Ubuntu Fan driver (V2/3/4) patches
      - debian/patches/1000-ubuntu-poc-fan-driver.patch
        Ubuntu FAN driver support V2 (LP 1439706)
      - debian/patches/1001-ubuntu-poc-fan-driver-v3.patch
        Ubuntu FAN driver support V3 (LP 1470091)
      - debian/patches/1002-ubuntu-poc-fan-driver-vxlan.patch
        Ubuntu FAN driver support VXLAN V4.
    - Drop: debian/patches/0001-Add-moo-feature.patch
    - set compat level 10 (no further changes needed)
    - Refresh: Ubuntu Fan driver (V2/3/4) patches
      Patches updated to apply against upstream 4.18 release.
  * Added changes:
    - debian/patches/1005-ubuntu-fix-testsuite-kenv.patch
      Fix testsuite failure if there are too many kernel config
      options.
    - Set debhelper dependency to >= 10 (no further changes needed)

 -- Stefan Bader <stefan.bader@canonical.com>  Wed, 22 Aug 2018 09:54:04 +0200

iproute2 (4.18.0-1) experimental; urgency=medium

  * Add Brazilian Portuguese translation for Debconf template. Thanks
    Adriano Rafael Gomes!
    (Closes: #903355)
  * Add Spanish translation for Debconf template. Thanks Jathan!
    (Closes: #903864)
  * Add German translation for Debconf template. Thanks Helge!
    (Closes: #906173)
  * Merge tag 'upstream/4.18.0'

 -- Luca Boccassi <bluca@debian.org>  Wed, 15 Aug 2018 11:44:27 +0100

iproute2 (4.17.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Luca Boccassi <bluca@debian.org>  Tue, 03 Jul 2018 21:23:37 +0100

iproute2 (4.17.0-1) experimental; urgency=medium

  * Add Dutch translation for debconf template. Thanks Frans Spiesschaert!
    (Closes: #899022)
  * Add French translation for debconf template. Thanks Alban Vidal!
    (Closes: #899320)
  * Merge tag 'upstream/4.17.0'
  * Drop patches merged upstream.

 -- Luca Boccassi <bluca@debian.org>  Sat, 09 Jun 2018 17:45:11 +0100

iproute2 (4.16.0-4ubuntu1) cosmic; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - debian/patches/1000-ubuntu-poc-fan-driver.patch [refreshed]
      Ubuntu FAN driver support V2 (LP 1439706)
    - debian/patches/1001-ubuntu-poc-fan-driver-v3.patch [refreshed]
      Ubuntu FAN driver support V3 (LP 1470091)
    - debian/patches/1002-ubuntu-poc-fan-driver-vxlan.patch [refreshed]
      Ubuntu FAN driver support VXLAN V4.
    - drop debian/patches/0001-Add-moo-feature.patch
    - set compat level 10 (no further changes needed)
  * Dropped (upstream)
    - d/p/netns-allow-negative-nsid: permit negative nsid using "auto".

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 30 Jul 2018 16:55:35 +0200

iproute2 (4.16.0-4) unstable; urgency=medium

  * Backport patch to fix regression in v6 automated parsing.
    (Closes: #898840)

 -- Luca Boccassi <bluca@debian.org>  Wed, 16 May 2018 17:49:44 +0100

iproute2 (4.16.0-3) unstable; urgency=medium

  * Add Russian translation for Debconf template. Thanks Lev Lamberov!
    (Closes: #898164)
  * Add Portuguese translation for Debconf template. Thanks Portuguese
    Translation Team!
    (Closes: #898292)
  * iproute2.postinst: use setcap -r instead of empty set.
    Thanks Mantas Mikulėnas!
  * Backport patch to avoid dropping caps if NET_ADMIN is inherited to
    avoid breaking applications that set ambient capabilities and then
    fork and exec ip.
    (Closes: #898015)
  * Re-enable pristine-tar (note: needs v1.43).

 -- Luca Boccassi <bluca@debian.org>  Tue, 15 May 2018 09:46:01 +0100

iproute2 (4.16.0-2) unstable; urgency=medium

  * Restrict iproute2 to linux-any

 -- Luca Boccassi <bluca@debian.org>  Thu, 03 May 2018 14:33:22 +0100

iproute2 (4.16.0-1) experimental; urgency=medium

  * Merge tag 'upstream/4.16.0' (Closes: #895719).
  * Drop 0005-revert-flush-default.patch, fixed upstream.
  * Build-Depend on libcap-dev and Depend on libcap-bin.
    If capabilities are set on /bin/ip, they will now be dropped
    immediately unless the command executed is ip vrf exec, in which case
    they will be dropped after the VRF has been switched, before forking.
  * Add capabilities to /bin/ip on postinst to fix ip vrf exec if the
    new low-priority debconf iproute2/setcaps is set to true (false by
    default).
  * Bump Standards-Version to 4.1.4, no changes.

 -- Luca Boccassi <bluca@debian.org>  Mon, 16 Apr 2018 14:44:50 +0100

iproute2 (4.15.0-3) unstable; urgency=medium

  * Backport 0005-revert-flush-default.patch to fix ip route flush all
    (Closes: #891511)

 -- Luca Boccassi <bluca@debian.org>  Mon, 12 Mar 2018 22:46:24 +0000

=== debian/control ===
--- 
+++ 
@@ -7,27 +7,29 @@
 Homepage: https://wiki.linuxfoundation.org/networking/iproute2
 Vcs-Browser: https://salsa.debian.org/debian/iproute2.git
 Vcs-Git: https://salsa.debian.org/debian/iproute2.git
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Build-Depends: bison,
-               debhelper (>= 9),
+               debhelper (>= 10),
                flex,
                iptables-dev,
                libatm1-dev,
+               libcap-dev,
                libdb-dev,
                libelf-dev,
                libmnl-dev,
                libselinux1-dev,
                linux-libc-dev,
                pkg-config,
+               po-debconf,
                zlib1g-dev,
 
 Package: iproute2
 Priority: important
-Architecture: any
+Architecture: linux-any
 Provides: arpd
 Conflicts: arpd, iproute (<< 20130000-1)
 Replaces: iproute
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, libcap2-bin,
 Recommends: ${ipmods:Recommends}
 Suggests: iproute2-doc
 Multi-Arch: foreign

=== debian/rules ===
#!/usr/bin/make -f

# for DEB_* variables
include /usr/share/dpkg/default.mk

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CROSS :=
else
	CROSS := CC=$(DEB_HOST_GNU_TYPE)-gcc HOSTCC=gcc PKG_CONFIG=$(DEB_HOST_GNU_TYPE)-pkg-config
endif

%:
	dh $@

override_dh_clean:
	dh_clean
	make distclean

override_dh_shlibdeps:
	dh_shlibdeps -a -Xq_atm.so -Xm_xt.so -Xm_ipt.so
	dh_shlibdeps -a -- -pipmods -dRecommends -e debian/iproute2/usr/lib/tc/m_xt.so -e debian/iproute2/usr/lib/tc/q_atm.so -xlibc6

override_dh_auto_configure:
	$(CROSS) dh_auto_configure

override_dh_auto_build:
	$(MAKE) KERNEL_INCLUDE=./include $(CROSS)

=== debian/tests/control ===
# the tests depend on the kernel and might break the env
# therefore do not run as build time tests
Tests: testsuite.sh
Restrictions: allow-stderr, isolation-machine, needs-root, breaks-testbed, rw-build-tree
Depends: libmnl-dev, build-essential, dpkg-dev

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s%.xz$%.sign%, decompress" \
	http://kernel.org/pub/linux/utils/net/iproute2/iproute2-(.+).tar.xz

## iproute2 4.19.0-cl4.3.1u14

=== Makefile ===
--- 
+++ 
@@ -16,6 +16,8 @@
 LIBDIR?=$(PREFIX)/lib
 SBINDIR?=/sbin
 CONFDIR?=/etc/iproute2
+NETNS_RUN_DIR?=/var/run/netns
+NETNS_ETC_DIR?=/etc/netns
 DATADIR?=$(PREFIX)/share
 HDRDIR?=$(PREFIX)/include/iproute2
 DOCDIR?=$(DATADIR)/doc/iproute2
@@ -34,7 +36,9 @@
 DEFINES+= -DNO_SHARED_LIBS
 endif
 
-DEFINES+=-DCONFDIR=\"$(CONFDIR)\"
+DEFINES+=-DCONFDIR=\"$(CONFDIR)\" \
+         -DNETNS_RUN_DIR=\"$(NETNS_RUN_DIR)\" \
+         -DNETNS_ETC_DIR=\"$(NETNS_ETC_DIR)\"
 
 #options for decnet
 ADDLIB+=dnet_ntop.o dnet_pton.o
@@ -50,7 +54,7 @@
 DEFINES += -D_GNU_SOURCE
 # Turn on transparent support for LFS
 DEFINES += -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
-CCOPTS = -O2
+CCOPTS = -O2 -g
 WFLAGS := -Wall -Wstrict-prototypes  -Wmissing-prototypes
 WFLAGS += -Wmissing-declarations -Wold-style-definition -Wformat=2
 
@@ -59,13 +63,26 @@
 
 SUBDIRS=lib ip tc bridge misc netem genl tipc devlink rdma man
 
-LIBNETLINK=../lib/libnetlink.a ../lib/libutil.a
+LIBNETLINK=../lib/libutil.a ../lib/libnetlink.a
 LDLIBS += $(LIBNETLINK)
 
 all: config.mk
 	@set -e; \
 	for i in $(SUBDIRS); \
 	do echo; echo $$i; $(MAKE) $(MFLAGS) -C $$i; done
+
+help:
+	@echo "Make Targets:"
+	@echo " all                 - build binaries"
+	@echo " clean               - remove products of build"
+	@echo " distclean           - remove configuration and build"
+	@echo " install             - install binaries on local machine"
+	@echo " check               - run tests"
+	@echo " cscope              - build cscope database"
+	@echo " snapshot            - generate version number header"
+	@echo ""
+	@echo "Make Arguments:"
+	@echo " V=[0|1]             - set build verbosity level"
 
 config.mk:
 	sh configure $(KERNEL_INCLUDE)
@@ -102,6 +119,9 @@
 
 distclean: clobber
 
+check:
+	@echo "Skipping check"
+
 cscope:
 	cscope -b -q -R -Iinclude -sip -slib -smisc -snetem -stc

=== ip/Makefile ===
--- 
+++ 
@@ -10,7 +10,8 @@
     link_iptnl.o link_gre6.o iplink_bond.o iplink_bond_slave.o iplink_hsr.o \
     iplink_bridge.o iplink_bridge_slave.o ipfou.o iplink_ipvlan.o \
     iplink_geneve.o iplink_vrf.o iproute_lwtunnel.o ipmacsec.o ipila.o \
-    ipvrf.o iplink_xstats.o ipseg6.o
+    ipvrf.o iplink_xstats.o ipseg6.o iplink_netdevsim.o iplink_rmnet.o \
+    ipnexthop.o
 
 RTMONOBJ=rtmon.o

=== testsuite/Makefile ===
# SPDX-License-Identifier: GPL-2.0
## -- Config --
DEV := lo
PREFIX := sudo -E unshare -n
RESULTS_DIR := results
## -- End Config --

HAVE_UNSHARED_UTIL := $(shell unshare --version 2> /dev/null)

rwildcard=$(wildcard $1$2) $(foreach d,$(wildcard $1*),$(call rwildcard,$d/,$2))

TESTS := $(patsubst tests/%,%,$(call rwildcard,tests/,*.t))
TESTS_DIR := $(dir $(TESTS))

IPVERS := $(filter-out iproute2/Makefile,$(wildcard iproute2/*))

KENVFN := $(shell mktemp /tmp/tc_testkenv.XXXXXX)
ifneq (,$(wildcard /proc/config.gz))
	KCPATH := /proc/config.gz
else
KVER := $(shell uname -r)
KCPATHS := /lib/modules/$(KVER)/config /boot/config-$(KVER)
KCPATH := $(firstword $(wildcard $(KCPATHS)))
endif

.PHONY: compile listtests alltests configure $(TESTS)

configure:
	echo "Entering iproute2" && cd iproute2 && $(MAKE) configure && cd ..;

compile: configure generate_nlmsg
	echo "Entering iproute2" && cd iproute2 && $(MAKE) && cd ..;

listtests:
	@for t in $(TESTS); do \
		echo "$$t"; \
	done

generate_nlmsg:
	$(MAKE) -C tools

alltests: generate_nlmsg $(TESTS)

testclean:
	@echo "Removing $(RESULTS_DIR) dir ..."
	@rm -rf $(RESULTS_DIR)

clean: testclean
	@rm -f iproute2/iproute2-this
	@rm -f tests/ip/link/dev_wo_vf_rate.nl
	$(MAKE) -C tools clean

distclean: clean
	echo "Entering iproute2" && cd iproute2 && $(MAKE) distclean && cd ..;

$(TESTS): testclean
ifeq (,$(IPVERS))
	$(error Please run make first)
endif
ifeq (,$(HAVE_UNSHARED_UTIL))
	$(error Please install util-linux tools to run tests in separated network namespace)
endif
	@./tools/generate_nlmsg

	@mkdir -p $(RESULTS_DIR)

	@for d in $(TESTS_DIR); do \
	    mkdir -p $(RESULTS_DIR)/$$d; \
	done

	@if [ "$(KCPATH)" = "/proc/config.gz" ]; then \
		gunzip -c $(KCPATH) >$(KENVFN); \
	elif [ "$(KCPATH)" != "" ]; then \
               cat $(KCPATH) >$(KENVFN); \
	fi
	@sed -i -e 's/^CONFIG_/export CONFIG_/' $(KENVFN)

	@for i in $(IPVERS); do \
		o=`echo $$i | sed -e 's/iproute2\///'`; \
		echo -n "Running $@ [$$o/`uname -r`]: "; \
		TMP_ERR=`mktemp /tmp/tc_testsuite.XXXXXX`; \
		TMP_OUT=`mktemp /tmp/tc_testsuite.XXXXXX`; \
		. $(KENVFN); \
		STD_ERR="$$TMP_ERR" STD_OUT="$$TMP_OUT" \
		TC="$$i/tc/tc" IP="$$i/ip/ip" SS=$$i/misc/ss BRIDGE="$$i/bridge/bridge" \
		DEV="$(DEV)" IPVER="$@" SNAME="$$i" \
		ERRF="$(RESULTS_DIR)/$@.$$o.err" $(PREFIX) tests/$@ > $(RESULTS_DIR)/$@.$$o.out; \
		if [ "$$?" = "127" ]; then \
			echo "SKIPPED"; \
		elif [ -e "$(RESULTS_DIR)/$@.$$o.err" ]; then \
			echo "FAILED"; \
		else \
			echo "PASS"; \
		fi; \
		rm "$$TMP_ERR" "$$TMP_OUT"; \
		sudo dmesg > $(RESULTS_DIR)/$@.$$o.dmesg; \
	done

=== debian/changelog ===
iproute2 (4.19.0-cl4.3.1u14) RELEASED; urgency=medium

  * new build for 4.3.1 from original hash
    d7b8b7d0125664dcd6901a625dd4f7c8bd6afff4

 -- root <root@7490f848894d>  Fri, 09 Sep 2022 08:41:07 +0000

iproute2 (4.19.0-cl4.3.0u1) RELEASED; urgency=medium
  [ Benjamin Poirier ]
  * CUMULUS: Update kernel headers to fix RTM_F_OFFLOAD_FAILED definition
  * CUMULUS: Update kernel headers

  [ Jan Engelhardt ]
  * build: fix build failure with -fno-common

  [ Michael Forney ]
  * ipmroute: Prevent overlapping storage of `filter` global

  [ Stephen Hemminger ]
  * ipxfrm: make local functions static

  [ Roopa Prabhu ]
  * CUMULUS: ip route: Print "rt_offload_failed"
  * sync kernel keaders for RTM_F_OFFLOAD_FAILED flag
  * iplink: add support for protodown reason
  * Update kernel headers for protodown reason

  [ Julien Fortin ]
  * Merge pull request #4 in CRMC/iproute2 from cumulus-4.19.y-bridge-fdb-get-json-support to cumulus-4.19.y
  * Merge pull request #5 in CRMC/iproute2 from CM-31077 to cumulus-4.19.y
  * iplink_bridge_slave: add json support for IFLA_BRPORT_GROUP_FWD_MASKHI
  * bridge: fdb get: add missing json init (new_json_obj)
  * bridge: fdb show: fix fdb entry state output for json context

 --  Cumulus Support <dev-support@cumulusnetworks.com>  Thu, 10 Dec 2020 19:04:50 +0000

iproute2 (4.19.0-cl4.2.1u1) RELEASED; urgency=medium

  [ Nikolay Aleksandrov ]
  * CUMULUS: bridge: use new fdb attr for notification control

  [ Zhiqiang Liu ]
  * ipnetns: use-after-free problem in get_netnsid_from_name func

  [ Donald Sharp ]
  * nexthop: Fix Deletion display

 -- Cumulus Support <dev-support@cumulusnetworks.com>  Tue, 08 Sep 2020 13:09:15 -0700

iproute2 (4.19.0-cl4u3) RELEASED; urgency=medium

  [ Mike Manning ]
  * iplink_vlan: add support for VLAN bridge binding flag

  [ Matteo Croce ]
  * ip route: print route type in JSON output

  [ Roopa Prabhu ]
  * bridge: fdb: add support for sticky flag
  * neighbour.h: sync fdb nexthop uapi with kernel
  * CUMULUS: bridge: fdb: support for nexthop id
  * CUMULUS: bridge: support for NDA_NOTIFY
  * CUMULUS: include: uapi: sync neighbour.h for neigh override flag
  * CUMULUS: ipneigh: add support for state_override_weak
  * CUMULUS: ipneigh: add support for mh_peer_sync neigh flag

 -- Cumulus Support <dev-support@cumulusnetworks.com>  Tue, 02 Jun 2020 16:51:31 -0700

iproute2 (4.19.0-cl4u2) RELEASED; urgency=medium

  [ Roopa Prabhu ]
  * CUMULUS: ipvrf: change RLIMIT_MEMLOCK to RLIM_INFINITY

  [ Andy Roulin ]
  * CUMULUS: include/uapi: update bonding kernel header
  * iplink: bond: print lacp actor/partner oper states as strings

  [ Benjamin Poirier ]
  * json_print: Remove declaration without implementation
  * testsuite: Fix line count test
  * bridge: Fix typo in error messages
  * bridge: Fix src_vni argument in man page
  * bridge: Fix BRIDGE_VLAN_TUNNEL attribute sizes
  * bridge: Fix vni printing
  * bridge: Deduplicate vlan show functions
  * bridge: Fix tunnelshow json output

  [ Donald Sharp ]
  * ip route: Do not imply pref and ttl-propagate are per nexthop

 -- Cumulus Support <dev-support@cumulusnetworks.com>  Mon, 02 Mar 2020 20:17:22 -0800

iproute2 (4.19.0-cl4u1) RELEASED; urgency=medium

  [ Nikolay Aleksandrov ]
  * bridge: mdb: restore text output format

  [ David Ahern ]
  * Update kernel headers
  * libnetlink: Set NLA_F_NESTED in rta_nest
  * lwtunnel: Pass encap and encap_type attributes to lwt_parse_encap
  * libnetlink: Add helper to add a group via setsockopt
  * uapi: Import nexthop object API
  * libnetlink: Add helper to create nexthop dump request
  * ip route: Export print_rt_flags, print_rta_if and print_rta_gateway
  * Add support for nexthop objects
  * ip: Add man page for nexthop command
  * ip route: Add option to use nexthop objects
  * ipmonitor: Add nexthop option to monitor

  [ David Ahern ]
  * libnetlink: Convert GETADDR dumps to use rtnl_addrdump_req
  * libnetlink: Convert GETROUTE dumps to use rtnl_routedump_req
  * libnetlink: Convert GETADDRLABEL dumps to use rtnl_addrlbldump_req
  * libnetlink: Convert GETMDB dumps to use rtnl_mdbdump_req
  * libnetlink: Convert GETNETCONF dumps to use rtnl_netconfdump_req
  * libnetlink: Convert GETRULE dumps to use rtnl_ruledump_req
  * libnetlink: Convert GETNEIGH dumps to use rtnl_neighdump_req
  * libnetlink: Convert GETNEIGHTBL dumps to use rtnl_neightbldump_req
  * libnetlink: Convert GETNSID dumps to use rtnl_nsiddump_req
  * libnetlink: Rename rtnl_wilddump_* to rtnl_linkdump_*
  * libnetlink: Rename rtnl_wilddump_stats_req_filter to rtnl_statsdump_req_filter
  * Tree wide: Drop sockaddr_nl arg
  * iplink: Remove flags argument from iplink_get
  * ip rule: Honor filter arguments on flush
  * ip rule: Require at least one argument for add
  * ip rule: Add ipproto and port range to filter list

  [ Phil Sutter ]
  * ip-route: Fix nexthop encap parsing
  * ip-address: Fix filtering by negated address flags

  [ Nicolas Dichtel ]
  * ipnetns: parse nsid as a signed integer

  [ Petr Machata ]
  * libnetlink: Process further iovs on no error

  [ David Ahern ]
  * libnetlink: dump extack string in done message
  * libnetlink: Use NLMSG_LENGTH to set nlmsg_len
  * libnetlink: linkdump_req: Only AF_UNSPEC family expects an ext_filter_mask
  * ip route: Remove rtnl_rtcache_request
  * ip route: Add protocol, table id and device to dump request
  * mroute: fix up family handling
  * mroute: Add table id attribute for kernel side filtering
  * ip address: Split ip_linkaddr_list into link and addr functions
  * ip address: Set device index in dump request
  * Update kernel headers
  * ip bridge: Set NETLINK_GET_STRICT_CHK on socket
  * ip route: Rename do_ipv6 to dump_family
  * neighbor: Add support for protocol attribute

  [ Ido Schimmel ]
  * bridge: fdb: Use 'struct ndmsg' for FDB dumping

  [ David Ahern ]
  * libnetlink: Add filter function to rtnl_neighdump_req
  * ip neigh: Convert do_show_or_flush to use rtnl_neighdump_req


=== debian/control ===
Source: iproute2
Section: net
Priority: optional
Maintainer: Debian iproute2 Maintainers <ah-iproute@debian.org>
Uploaders: Roopa Prabuu <roopa@cumulusnetworks.com>
Homepage: http://www.linux-foundation.org/en/Net:Iproute2
Standards-Version: 4.3.0
Build-Depends: bison,
               debhelper (>= 10~),
               flex,
               iptables-dev,
               libatm1-dev,
               libcap-dev,
               libelf-dev,
               libmnl-dev,
               libselinux1-dev,
               linux-libc-dev,
               pkg-config,
               po-debconf,
               zlib1g-dev,
               git
XS-Build-Source: True
XS-Cumulus-Valid-Arch: amd64 armel
XBCS-Vcs-Hash: d7b8b7d0125664dcd6901a625dd4f7c8bd6afff4

Package: iproute2
Priority: important
Architecture: linux-any
Provides: arpd
Conflicts: arpd, iproute (<< 20130000-1)
Replaces: iproute
Depends: ${misc:Depends}, ${shlibs:Depends}, libcap2-bin
Recommends: ${ipmods:Recommends}
Suggests: iproute2-doc
Multi-Arch: foreign
Description: networking and traffic control tools
 The iproute2 suite is a collection of utilities for networking and
 traffic control.
 .
 These tools communicate with the Linux kernel via the (rt)netlink
 interface, providing advanced features not available through the
 legacy net-tools commands 'ifconfig' and 'route'.
XBCS-Vcs-Hash: d7b8b7d0125664dcd6901a625dd4f7c8bd6afff4

Package: iproute2-doc
Section: doc
Architecture: all
Conflicts: iproute-doc (<< 20130000-1)
Replaces: iproute-doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: networking and traffic control tools - documentation
 The iproute2 suite is a collection of utilities for networking and
 traffic control.
 .
 This package contains the documentation for iproute.
XBCS-Vcs-Hash: d7b8b7d0125664dcd6901a625dd4f7c8bd6afff4
